////////////////////////////////////////////
// Res-Studios.net
///////////////////////////////////////////
class L2GPBossZombieSpawner extends Actor
    placeable;

struct SpawnTime
{
    var() float Min;
    var() float Max;
};

var() SpawnTime BossZombieSpawnTime;
var() array< class<L2GPBossZombie> > BossZombieClasses;
var() class<Emitter> BossSpawnEmitterClass;

simulated function PostBeginPlay()
{
    Super.PostBeginPlay();

    SetBossTimer();
}

simulated function float GetSpawnTime()
{
    return BossZombieSpawnTime.Min + FRand()*(BossZombieSpawnTime.Max - BossZombieSpawnTime.Min);
}

simulated function SetBossTimer()
{
    SetTimer(GetSpawnTime(), false);
}

simulated function Timer()
{
    local int SpawnIndex;
    local vector SpawnLocation;
    local vector HitLocation, HitNormal, EndTrace, StartTrace;
    local Actor Other;
    local Controller BossController;
    local L2GPBossZombie Boss;
    local P2Player PController;

    StartTrace = Location;
    EndTrace = StartTrace + vect(0,0,-8192);
    Other = Trace(HitLocation, HitNormal, EndTrace, StartTrace);

    if (Other != None)
    {
        SpawnIndex = Rand(BossZombieClasses.length);
        SpawnLocation = HitLocation;

        if (BossZombieClasses[SpawnIndex] != None)
            Boss = Spawn(BossZombieClasses[SpawnIndex]);

        if (Boss != None && Boss.ControllerClass != None)
        {
            SpawnLocation.Z += Boss.CollisionHeight;
            Boss.SetLocation(SpawnLocation);
            Boss.BossSpawner = self;

            if (BossSpawnEmitterClass != None)
                Spawn(BossSpawnEmitterClass,,, SpawnLocation);

            BossController = Spawn(Boss.ControllerClass);
        }

        if (BossController != None)
        {
            BossController.Possess(Boss);

            foreach DynamicActors(class'P2Player', PController)
                if (PController != None)
                    PController.SendHintText(Boss.SpawnMessage, 5);
        }
    }
    else
        log("Invalid Location for Boss Spawner, can't find floor.");
}

defaultproperties
{
     BossZombieSpawnTime=(Min=10.000000,Max=20.000000)
     BossZombieClasses(0)=Class'Left2GoPostal.L2GPMikeJ'
     bHidden=True
     bEdShouldSnap=True
}
