////////////////////////////////////////////
// Res-Studios.net
///////////////////////////////////////////
class L2GPFireStorm extends Actor
    placeable;

struct IdleTime
{
    var() float Min;
    var() float Max;
};

var() IdleTime FirestormIdleInterval;
var() int FireStormProjectileCount;
var() float FireStormSpawnInterval;
var() float FireStormRadius;

var bool bSpawning;
var int CurrentProjectileCount;

simulated function PostBeginPlay()
{
    Super.PostBeginPlay();

    SetTimer(GetIdleInterval(), false);
}

simulated function float GetIdleInterval()
{
    return FireStormIdleInterval.Min + FRand()*(FireStormIdleInterval.Max - FireStormIdleInterval.Min);
}

simulated function RainFireball()
{
    local vector SpawnLocation;
    local L2GPMikeJFireballProjectile FireballRain;

    SpawnLocation = Location;
    SpawnLocation.X -= FireStormRadius;
    SpawnLocation.Y -= FireStormRadius;
    SpawnLocation.X += (FireStormRadius*FRand()*2);
    SpawnLocation.Y += (FireStormRadius*Frand()*2);

    FireballRain = Spawn(class'L2GPMikeJFireballProjectile',,, SpawnLocation);

    if (FireballRain != None)
    {
        FireballRain.Velocity = vect(0,0,-2000);
        CurrentProjectileCount++;
    }
}

simulated function Timer()
{
    if (bSpawning)
    {
        RainFireball();

        if (CurrentProjectileCount == FireStormProjectileCount)
        {
            CurrentProjectileCount = 0;
            bSpawning = false;
            SetTimer(GetIdleInterval(), false);
        }
        else
            SetTimer(FireStormSpawnInterval, false);
    }
    else
    {
        bSpawning = true;
        Timer();
    }
}

defaultproperties
{
     FirestormIdleInterval=(Min=20.000000,Max=40.000000)
     FireStormProjectileCount=100
     FireStormSpawnInterval=0.070000
     FireStormRadius=3072.000000
     bHidden=True
     bEdShouldSnap=True
}
