////////////////////////////////////////////
// Res-Studios.net
///////////////////////////////////////////
class L2GPMikeJ extends L2GPBossZombie
    placeable;

var bool bThrowRight;

var name IdleAnim;
var name LaughAnim;
var name WalkAnim;
var name DieAnim;
var name SpitHeadAnim;
var name SendHeadsAnim;
var name FireStormAnim;

var int FireStormProjectiles;
var int FireStormProjectileCount;

var float AttackRange;
var float FireStormChance;
var float FireStormRadius;

var float LaughAnimDuration;
var float DieAnimDuration;
var float SendHeadsAnimDuration;
var float FireStormDuration;

var vector FireStormStart;

var sound GibSound;

var P2Emitter LeftFootFire;
var P2Emitter RightFootFire;
var P2Emitter LeftThingyFire;
var P2Emitter RightThingyFire;

var P2Emitter FireballEmitter;

const BONE_LEFTFOOT		=	'Bip01 L Toe0';
const BONE_RIGHTFOOT	=	'Bip01 R Toe0';
const BONE_MOUTH		=	'Bip01 Head';
const BONE_LEFTHAND		=	'Bip01 L Hand';
const BONE_RIGHTHAND	=	'Bip01 R Hand';
const BONE_LEFTTHINGY   =   'Dummy01';
const BONE_RIGHTTHINGY  =   'Dummy02';

simulated function PostNetBeginPlay()
{
    local L2GPMikeJFireballEmitter FireEmitter;

    Super.PostBeginPlay();

}

simulated function bool IsInAttackRange(Actor Other)
{
    if (VSize(Other.Location - Location) <= AttackRange)
        return true;
    else
        return false;
}

simulated function vector GetRandomTossVelocity(float Magnitude)
{
    local vector TossVelocity;

    TossVelocity.X = FRand()*Magnitude;
    TossVelocity.Y = FRand()*Magnitude;
    TossVelocity.Z = FRand()*Magnitude;

    return TossVelocity;
}

simulated function PlayFalling();
simulated event PlayLandingAnimation(float ImpactVel);
simulated event AnimEnd(int Channel);

simulated function PlayMoving()
{
    SetAnimWalking();
}

simulated function name GetAnimIdle()
{
    return IdleAnim;
}

simulated function name GetAnimStand()
{
    return IdleAnim;
}

simulated function GetFireStormStart()
{
    local vector HitLocation, HitNormal, EndTrace, StartTrace;
    local Actor Other;

    StartTrace = Location;
    EndTrace = StartTrace + vect(0,0,16384);

    Other = Trace(HitLocation, HitNormal, EndTrace, StartTrace, false);

    if (Other != None)
        FireStormStart = HitLocation - vect(0,0,64);
    else
        FireStormStart = EndTrace - vect(0,0,64);
}

simulated function SetAnimWalking()
{
    local int i;

    BaseMovementRate = GroundSpeed;

    if (HasAnim(WalkAnim))
        for (i=0;i<4;i++)
            MovementAnims[i] = WalkAnim;
}

simulated function ThrowFireball()
{
    local L2GPMikeJFireballProjectile Fireball;

    if (FireballEmitter != None)
    {
        DetachFromBone(FireballEmitter);
        FireballEmitter.Destroy();
        FireballEmitter = None;
    }

    if (bThrowRight)
        Fireball = Spawn(class'L2GPMikeJFireballProjectile',,, GetBoneCoords(BONE_RIGHTHAND).Origin);
    else
        Fireball = Spawn(class'L2GPMikeJFireballProjectile',,, GetBoneCoords(BONE_LEFTHAND).Origin);

    if (Fireball != None)
        Fireball.Velocity = vector(rotator(Controller.Enemy.Location - Fireball.Location)) * 1500;
}

simulated function RainFireball()
{
    local vector SpawnLocation;
    local L2GPMikeJFireballProjectile FireballRain;

    SpawnLocation = FireStormStart;
    SpawnLocation.X -= FireStormRadius;
    SpawnLocation.Y -= FireStormRadius;
    SpawnLocation.X += (FireStormRadius*FRand()*2);
    SpawnLocation.Y += (FireStormRadius*Frand()*2);

    FireballRain = Spawn(class'L2GPMikeJFireballProjectile',,, SpawnLocation);

    if (FireballRain != None)
    {
        FireballRain.Velocity = vect(0,0,-2000);
        FireStormProjectileCount++;
    }
}

simulated function DestroyAllFireballs()
{
    local L2GPMikeJFireballProjectile Fireball;

    foreach DynamicActors(class'L2GPMikeJFireballProjectile', Fireball)
        if (Fireball != None)
            Fireball.GenerateHarmlessExplosion();
}

simulated function TakeDamage(int Damage, Pawn EventInstigator, vector HitLocation, vector Momentum, class<DamageType> DamageType)
{
    if (ClassIsChildOf(DamageType, class'L2GPMikeJFireballDamage') ||
        ClassIsChildOf(DamageType, class'BurnedDamage'))
        return;

    Health -= Damage;

    Spawn(class'BloodImpactMP',,, HitLocation, rotator(Momentum));

    if (Health <= 0)
    {
        if (ClassIsChildOf(DamageType, class'ExplodedDamage'))
            ChunkUp(0);

        Super.TakeDamage(Damage, EventInstigator, HitLocation, Momentum, DamageType);

        GotoState('Dying');
    }
}

simulated function ChunkUp(int Damage)
{
	local CatExplosion exp;
	bChunkedUp = true;

	if (class'P2Player'.static.BloodMode())
	{
		Spawn(class'PawnExplosion',,,GetBoneCoords('Box10').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Box12').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Box08').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Box04').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Box13').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Box11').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 Head').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 Neck').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 R UpperArm').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 L UpperArm').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 Spine2').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 Spine1').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 R Forearm').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 L Forearm').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 R Hand').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 L Hand').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 R Calf').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 L Calf').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 R HorseLink').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 L HorseLink').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 R Foot').Origin);
		Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 L Foot').Origin);

		Spawn(class'FireMatch',,,GetBoneCoords('Box10').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Box12').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Box08').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Box04').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Box13').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Box11').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 Head').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 Neck').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 R UpperArm').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 L UpperArm').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 Spine2').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 Spine1').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 R Forearm').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 L Forearm').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 R Hand').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 L Hand').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 R Calf').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 L Calf').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 R HorseLink').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 L HorseLink').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 R Foot').Origin);
		Spawn(class'FireMatch',,,GetBoneCoords('Bip01 L Foot').Origin);
		spawn(class'RocketSmokePuff',,,Location);
		spawn(class'NapalmExplosion',,,Location);
		exp = Spawn(class'PawnExplosion',,,GetBoneCoords('Bip01 Spine').Origin);

	

        if (exp != None)
			exp.PlaySound(GibSound);
		
	}
	Super.ChunkUp(Damage);

	Destroy();
}

simulated event Bump(Actor Other)
{
    if (VSize(Velocity) > 0)
    {
        if (Other.IsA('L2GPZombie'))
            L2GPZombie(Other).ChunkUp(0);
    }
}

simulated state Idle
{
Begin:
    ChangeAnimation();
}

simulated state Laugh
{
Begin:
    SetAnimAction(LaughAnim);

    Sleep(LaughAnimDuration);

    Controller.GotoState('Idle');
    GotoState('Idle');
}

simulated state Hunting
{
    simulated function Tick(float DeltaTime)
    {
        if (IsInAttackRange(Controller.Enemy))
        {
            if (Health < (HealthMax/2) && FRand() < FireStormChance)
            {
                Controller.GotoState('Attacking');
                GotoState('FireStorm');
            }
            else
            {
                Controller.GotoState('Attacking');
                GotoState('Attacking');
            }
        }
    }

Begin:
    ChangeAnimation();
}

simulated state Attacking
{
Begin:
    Goto 'AttackLoop';

AttackLoop:
    StopAnimating();
    StopAcc();

    /*
    if (FireballEmitter == None)
    {
        if (bThrowRight)
            FireballEmitter = Spawn(class'L2GPMikeJFireballEmitter', self,, GetBoneCoords(BONE_RIGHTHAND).Origin);
        else
            FireballEmitter = Spawn(class'L2GPMikeJFireballEmitter', self,, GetBoneCoords(BONE_LEFTHAND).Origin);
    }
    */

    if (FireballEmitter != None)
    {
        if (bThrowRight)
            AttachToBone(FireballEmitter, BONE_RIGHTHAND);
        else
            AttachToBone(FireballEmitter, BONE_LEFTHAND);
    }

    if (bThrowRight)
    {
        SetAnimAction(AttackInformation[0].AttackAnim);
        Sleep(AttackInformation[0].AttackDelay);
    }
    else
    {
        SetAnimAction(AttackInformation[1].AttackAnim);
        Sleep(AttackInformation[1].AttackDelay);
    }

    ThrowFireball();

    if (bThrowRight)
        Sleep(AttackInformation[0].AttackDuration - AttackInformation[1].AttackDelay);
    else
        Sleep(AttackInformation[1].AttackDuration - AttackInformation[1].AttackDelay);

    bThrowRight = !bThrowRight;

    if (Controller.Enemy != None && Controller.Enemy.Health > 0 && IsInAttackRange(Controller.Enemy))
    {
        if (Health < (HealthMax/2) && FRand() < FireStormChance)
            GotoState('FireStorm');
        else
            Goto 'AttackLoop';
    }
    else
    {
        Controller.GotoState('Idle');
        GotoState('Idle');
    }
}

simulated state FireStorm
{
Begin:
    StopAnimating();
    StopAcc();

    SetAnimAction(FireStormAnim);

    GetFireStormStart();

    Goto 'FireStormLoop';

FireStormLoop:
    RainFireball();

    Sleep(FireStormDuration/FireStormProjectiles);

    if (FireStormProjectileCount == FireStormProjectiles)
    {
        FireStormProjectileCount = 0;
        Controller.GotoState('Idle');
        GotoState('Idle');
    }
    else
        Goto 'FireStormLoop';
}

simulated state SpawnHeads
{
}

simulated state SendHeads
{
}

simulated state Dying
{
    simulated function TakeDamage(int Damage, Pawn EventInstigator, vector HitLocation, vector Momentum, class<DamageType> DamageType);

Begin:
    DestroyAllFireballs();

    StopAnimating();
    StopAcc();

    SetAnimAction(DieAnim);

    Sleep(DieAnimDuration);

    ChunkUp(0);
}


defaultproperties
{
     bThrowRight=True
     IdleAnim="cb_idle"
     LaughAnim="cb_laugh"
     WalkAnim="cb_walk"
     DieAnim="cb_die"
     SpitHeadAnim="cb_spit_head"
     SendHeadsAnim="cb_uttershoot"
     FireStormAnim="cb_uttershoot"
     FireStormProjectiles=100
     AttackRange=2048.000000
     FireStormRadius=3072.000000
     LaughAnimDuration=3.000000
     DieAnimDuration=3.000000
     SendHeadsAnimDuration=7.066666
     FireStormDuration=7.066666
     GibSound=Sound'Left2GoPostalSnd.MikeJ.Mikej_JDLDeath'
     AttackInformation(0)=(AttackAnim="cb_right_throw",AttackDelay=1.933333,AttackDuration=3.366667)
     AttackInformation(1)=(AttackAnim="cb_left_throw",AttackDelay=1.933333,AttackDuration=3.366667)
     SpawnMessage="WATCH OUT! THE JEW COW IS CUMMING!!!!!"
     CoreMeshAnim=None
     HealthMax=5000.000000
     GroundSpeed=224.000000
     Health=5000.000000
     ControllerClass=Class'Left2GoPostal.L2GPMikeJController'
     MovementAnims(0)="None"
     MovementAnims(1)="None"
     MovementAnims(2)="None"
     MovementAnims(3)="None"
     TurnLeftAnim="None"
     TurnRightAnim="None"
     Physics=PHYS_Walking
     LODBias=3.000000
	 Mesh=SkeletalMesh'Left2GoPostalAnim.CowBoss'
     PrePivot=(Z=-16.000000)
     CollisionRadius=120.000000
     CollisionHeight=200.000000
     bEdShouldSnap=True
}
