////////////////////////////////////////////
// Res-Studios.net
///////////////////////////////////////////
class L2GPMikeJController extends FPSController;

var float TargetCheckInterval;
var float PathUpdateInterval;

var L2GPMikeJ MikeJ;

function Possess(Pawn aPawn)
{
    Super.Possess(aPawn);

    MikeJ = L2GPMikeJ(aPawn);

    FindClosestSurvivor();

    MikeJ.GotoState('Idle');
    GotoState('Idle');
}

simulated function FindClosestSurvivor()
{
    local float Distance;
    local PersonPawn temp;
    local PersonPawn Closest;

    Distance = 0;

    foreach DynamicActors(class'PersonPawn', temp)
    {
        if (temp.Health > 0)
        {
            if (Distance == 0)
            {
                Enemy = temp;
                Distance = VSize(temp.Location - Pawn.Location);
            }
            else if (VSize(temp.Location - Pawn.Location) < Distance)
            {
                Enemy = temp;
                Distance = VSize(temp.Location - Pawn.Location);
            }
        }
    }

    if (Enemy != None)
    {
        MikeJ.GotoState('Hunting');
        GotoState('Hunting');
    }
}

simulated state Idle
{
Begin:
    FindClosestSurvivor();

    log("Check");

    Sleep(TargetCheckInterval);

    Goto 'Begin';
}

simulated state Laugh
{
}

simulated state Hunting
{
Begin:
    Goto 'PathUpdateLoop';

PathUpdateLoop:
    if (Enemy == None)
        GotoState('Idle');

    if (CanSee(Enemy))
        MoveToward(Enemy);
    else
        MoveToward(FindPathToward(Enemy));

    Sleep(PathUpdateInterval);
    Goto 'PathUpdateLoop';
}

simulated state Attacking
{
Begin:
    MoveToward(Pawn, Enemy);
}

defaultproperties
{
     TargetCheckInterval=1.000000
     PathUpdateInterval=0.500000
}
