////////////////////////////////////////////
// Res-Studios.net
///////////////////////////////////////////
class L2GPZombieController extends FPSController;

var float WalkPathUpdateInterval;
var float RunPathUpdateInterval;

var float TargetCheckInterval;
var float TargetCheckRadius;

var float ArrivedRadius;
var PathNode InitialPathNode;

var Actor EnemyPathNode;
var Actor Destination;

var L2GPZombie Zombie;

function Possess(Pawn aPawn)
{
    Super.Possess(aPawn);

    Zombie = L2GPZombie(aPawn);

    GotoState('MoveToInitialNode');
}

simulated function SetEnemy(Pawn NewEnemy)
{
    Enemy = NewEnemy;
    Pawn.GotoState('Chasing');
    GotoState('Chasing');
}

simulated function CheckForTargets()
{
    local PersonPawn Victim;

    foreach VisibleCollidingActors(class'PersonPawn', Victim, TargetCheckRadius, Zombie.Location)
        if (Victim != None && Victim.Health > 0 && !Victim.IsA('L2GPZombie') && !Victim.IsA('AnimalPawn'))
        {
            Enemy = Victim;
            Pawn.GotoState('Chasing');
            GotoState('Chasing');
        }
}

simulated state Idle
{
Begin:
    MoveToward(Pawn);
    Goto 'TargetCheckLoop';

TargetCheckLoop:
    CheckForTargets();
    Sleep(TargetCheckInterval);
    Goto 'TargetCheckLoop';
}

simulated state MoveToInitialNode
{
    simulated function BeginState()
    {
        SetTimer(TargetCheckInterval, true);
    }

    simulated function Timer()
    {
        CheckForTargets();
    }

Begin:
    Goto 'PathUpdateLoop';

PathUpdateLoop:
    if (InitialPathNode == None)
        InitialPathNode = PathNode(FindRandomDest());

    if (VSize(InitialPathNode.Location - Pawn.Location) <= ArrivedRadius)
        GotoState('Idle');

    //if (FastTrace(InitialPathNode.Location - Pawn.Location))
        //MoveToward(InitialPathNode);
    //else
        MoveToward(FindPathToward(InitialPathNode));

    if (Zombie.bRuns)
        Sleep(RunPathUpdateInterval);
    else
        Sleep(WalkPathUpdateInterval);

    Goto 'PathUpdateLoop';
}

simulated state Chasing
{
Begin:
    Goto 'PathUpdateLoop';

PathUpdateLoop:
    if (CanSee(Enemy))
        MoveToward(Enemy);
    else
        MoveToward(FindPathToward(Enemy));

    if (Zombie.bRuns)
        Sleep(RunPathUpdateInterval);
    else
        Sleep(WalkPathUpdateInterval);

    Goto 'PathUpdateLoop';
}

simulated state Attacking
{
Begin:
    MoveToward(Pawn, Enemy);
}

simulated state Dead
{
}

defaultproperties
{
     WalkPathUpdateInterval=0.250000
     RunPathUpdateInterval=0.250000
     TargetCheckInterval=1.000000
     TargetCheckRadius=1024.000000
     ArrivedRadius=512.000000
}
