class MutZombies extends xMutator 
    config(XLXtras1409);
 
struct RuneStruct
{
	var class<P2WeaponPickup> WeaponPickupClass;
};

var config float SLEEP_TIME; // amount of time to wait between performing inventory on runes
var config int MAX_PICKUPS; // Max number of Air Mail pickups/inventory allowed at a time
var config array<RuneStruct> Runes; // String array of air mail pickup classes. Make this length the same as MAX_AIRMAIL

var array<NavigationPoint> ValidMailDrops;
var string AirMailVer;

// Ensures our AirMailRules come into effect.
function PostBeginPlay()
{
	local GameRules foo;

	SetupMailDrops();

	SetTimer(SLEEP_TIME, true);
}

function SetupMailDrops()
{
	local int i;
	local NavigationPoint N;

	for (N = Level.NavigationPointList; N != None; N=N.NextNavigationPoint)
	{
		if (ClassIsChildOf(N.Class, class'PathNode') && N.Tag != 'NoAirmail')
		{
			ValidMailDrops.Insert(0,1);
			ValidMailDrops[0] = N;
		}
	}
}

// RandomSpot()
// Returns a random path node.
function vector RandomSpot()
{
	return ValidMailDrops[Rand(ValidMailDrops.Length)].Location;
}

function vector FindDropPoint(vector SourceLoc)
{
	local Actor HitActor;
	local vector HitLocation, HitNormal, checkpos;
	local Rotator userot;
	local vector NewDropPoint;

	checkpos = SourceLoc;
	checkpos.z += 600;

	HitActor = Trace(HitLocation, HitNormal, checkpos, SourceLoc, false);
	if(HitActor != None)
	{
		HitLocation+=CollisionHeight*HitNormal;
		NewDropPoint=HitLocation;
	}
	else
		NewDropPoint=CheckPos;

	return NewDropPoint;
}

// See if we need to spawn any more air mail pickups.
function DoInventory()
{
	local int RunesFound; // number of pickups/inventory found
	//local AirMailInv ami;
	local L2GPZombieSpawner2 amp;
	local int RunesToSpawn; // Number of pickups we need to spawn
	local int RunesSpawned; // Number of pickups spawned
	local vector PlaceLoc;
	local int RandRune;
	local class<L2GPZombieSpawner2> PickupToSpawn;
	local bool bFinalized;
	local int Count;

	// Check for air mails being held by players
	//foreach DynamicActors(class'AirMailInv', ami)
	//	RunesFound++;

	// Check for pickups on the ground
	foreach DynamicActors(class'L2GPZombieSpawner2', amp)
		RunesFound++;

	//log ("Found" @ RunesFound @ "airmails in level," @ MAX_PICKUPS @ "required");
	if (RunesFound < MAX_PICKUPS)
	{
		RunesToSpawn = MAX_PICKUPS - RunesFound;

		// Spawn extra pickups
		for(RunesSpawned = 1; RunesSpawned <= RunesToSpawn; RunesSpawned++)
		{
			PlaceLoc = RandomSpot();
			bFinalized = false;
			Count=0;
			while (!bFinalized && Count < 1000)
			{
				Count++;
				
					bFinalized = True;
			}

			//PickupToSpawn = class<AirMailPickup>(DynamicLoadObject(Runes[RandRune].RuneName, class'Class'));
			//PickupToSpawn = class'Armory

			//log ("Attempting to place" @ PickupToSpawn @ "at" @ PlaceLoc);
			PlaceLoc = FindDropPoint(PlaceLoc);
			amp = spawn(class'L2GPZombieSpawner2',,,PlaceLoc);
//			if (amp == None)
//				warn("Couldn't drop" @ PickupToSpawn @ "at" @ PlaceLoc);
//			else
//			{
				amp.FindGround();
				//spawn(class'AirMailAppearEffects',,,amp.location);
				spawn(class'L2GPZombieSpawner2',,,amp.location);
				//amp.InventoryType = Runes[RandRune].WeaponPickupClass.Default.InventoryType;
				//amp.ShortSleeveType = Runes[RandRune].WeaponPickupClass.Default.ShortSleeveType;
				//amp.MPAmmoGiveCount = Runes[RandRune].WeaponPickupClass.Default.MPAmmoGiveCount;
//			}
		}
	}
}

event Timer()
{
	DoInventory();
}

defaultproperties
{
     GroupName="Zombies Bitch"
     FriendlyName="Zombies Bitch"
     Description="I SAID FUCKIN' ZOMBIES BITCH!"
	 MAX_PICKUPS=16
	 SLEEP_TIME=5
}
